<?php
/*                                                       */
/* go_export.php - Action for print/export reservations  */
/* $ID 189 - 2023-09-11 - brom $                         */
/*                                                       */
/* BROM CMS/BelCal Project  <http://www.brom-belcal.de>  */
/*                                                       */
/* BROM CMS/BelCal is software you can redistribute it   */
/* under the terms the BROM CMS/BelCal license for free  */
/* and modify scripts but without warranty. It is not    */
/* redistributable for payment.                          */
/*                                                       */
/* A distribution of payment will be provided            */
/* exclusively by BROM Service see website or send mail. */
/*                                                       */
/* (c) by BROM-Service 2008  (kontakt@brom-belcal.de)    */
/*                                                       */

// Include config
require_once('../../config/config.php');

// Get language from calendar
if(!file_exists(BC_PATH .'/modules/calendar/languages/'.LANGUAGE .'.php')) {
  // no module language file exists for the language set by the user, include default module language file EN.php
  require(BC_PATH .'/modules/calendar/languages/EN.php');
}
else {
  // a module language file exists for the language defined by the user, load it
  require(BC_PATH .'/modules/calendar/languages/'.LANGUAGE .'.php');
}
if(file_exists(BC_PATH .'/modules/calendar/languages/user_'.LANGUAGE .'.php')) {
  require(BC_PATH .'/modules/calendar/languages/user_'.LANGUAGE .'.php');
}

if(LANGUAGE != 'EN'){ $dec_point = ','; $thousends = '.'; }else{ $dec_point = '.'; $thousends = ','; }

// Get local charset by language
switch (LANGUAGE){
  case 'CS':
  case 'PL':
    $local_charset = 'ISO-8859-2';
    break;
  case 'ES':
  case 'PT':
    $local_charset = 'ISO-8859-3';
    break;
  case 'DE':
  case 'IT':
  case 'FR':
  case 'EN':
  case 'NL':
  default:
    $local_charset = 'ISO-8859-1';
}

// Create new admin object
require(BC_PATH.'/lib/classes/class.admin.php');
if(isset($_POST['export'])){
  $is_export = true;
  $admin = new admin('Reservations', 'reservations_view', 'system', false);
}
else{
  $is_export = false;
  $admin = new admin('Reservations', 'reservations_view', 'system');
}
// include the functions
require_once(BC_PATH.'/lib/functions.php');
$user_id = $admin->get_user_id();
$js_back = 'javascript:history.go(-1)';
// The filter from list
$f_start = '';
$f_end = '';
$f_old = '1';
$f_storno = '0';
$f_blocked = '0';
$f_start_unix = NULL;
$f_end_unix = NULL;
$f_text = '';
$all_back = ADMIN_URL.'/reservations/index.php';
$is_object = false;
$filter_sql2 = "o.`object_id`=r.`object_id`";
if(isset($_POST['object_id']) AND is_numeric($_POST['object_id']) AND isset($_POST['section_id']) AND is_numeric($_POST['section_id'])){
  $object_id = $admin->get_post('object_id');
  $section_id = $admin->get_post('section_id');
  if(!$admin->get_object_permission($object_id)){
    $admin->print_error($MESSAGE['ADMIN']['INSUFFICIENT_PRIVELLIGES'],$all_back);
  }
  $filter_sql2 .= " AND r.`object_id`='".$object_id."'";
  $is_object = true;
}
// Include the check of filter is set
include(ADMIN_PATH.'/reservations/filtercheck.php');
$filter_objsql = ($is_object == true?'':$filter_objsql);
$rstatus_0 = 0;
$rstatus_2 = 0;
$rstatus_3 = 0;
$rstatus_4 = 0;
$rstatus_5 = 0;
$rstatus_0d = 0;
$rstatus_2d = 0;
$rstatus_3d = 0;
$rstatus_4d = 0;
$rstatus_5d = 0;
$rstatus_0p = 0;
$rstatus_2p = 0;
$rstatus_3p = 0;
$rstatus_4p = 0;
$rstatus_5p = 0;
$rstatus_0s = 0;
$rstatus_2s = 0;
$rstatus_3s = 0;
$rstatus_4s = 0;
$rstatus_5s = 0;
$statistics = (isset($_SESSION['filter']['start'])?$_SESSION['filter']['start']:'');
$goback = $admin->get_post('goback');
switch($goback){
  case 'l':
    $all_back = ADMIN_URL.'/reservations/listing.php';
    break;
  case 'r';
    $all_back = ADMIN_URL.'/reservations/'.(isset($object_id)?'reservations.php?object_id='.$object_id.ARGSOJS.'section_id='.$section_id:'index.php');
    break;
  case 'c';
    $all_back = ADMIN_URL.'/reservations/calendar.php';
    break;
  case 'i':
  default:
    $all_back = ADMIN_URL.'/reservations/index.php';
    break;
}

// Get the selected fields
$field_array = array();
$fldn_array = array();
$names_array = array();
$is_calc = false;
$is_address = false;
$sumspan1 = 0;
$sumspan2 = 0;
$fldforsave = '';
for($i=0;$i<33;$i++){
  $n = '';
  if($i==4){
    $ftemp = 'res_start';
    $f = "r.`".$ftemp."`";
    $n = $admin->get_post('nfld'.$i);
  }
  elseif($i==5){
    $ftemp = 'res_end';
    $f = "r.`".$ftemp."`";
    $n = $admin->get_post('nfld'.$i);
  }
  elseif($i==11){
    $ftemp = 'status';
    $f = "r.`".$ftemp."`";
    $n = $admin->get_post('nfld'.$i);
  }
  elseif($i==16){
    $ftemp = $admin->get_post('fld'.$i);
    if($ftemp == NULL){ continue 1; }
    $f = 'resfiles';
    $n = $admin->get_post('nfld'.$i);
  }
  else{
//  if(!isset($_POST['fld'.$i])){ continue; }
    $ftemp = $admin->get_post('fld'.$i);
    if(empty($ftemp) OR $ftemp == NULL){ continue 1; }
    if($i==2){ $f = "o.`".$ftemp."`"; }
    elseif($i==6 OR $i==12 OR $i==13){
      $f = "c.`".$ftemp."`";
      $is_calc = true;
    }
    elseif($i>16){ $f = "a.`".$ftemp."`"; $is_address = true; }
    else{ $f = "r.`".$ftemp."`"; }
    $n = $admin->get_post('nfld'.$i);
  }
  $_SESSION['export']['nfld'.$i] = $n;
  if($n != ''){ $fldforsave .= (!empty($fldforsave)?'|':'').'nfld'.$i; }
  $fldn_array[$i]=$ftemp;
  $field_array[$i]=$f;
  $names_array[$i]=$n;
  if($i<12 AND !empty($n)){ $sumspan1++; }
  if($i>13 AND !empty($n)){ $sumspan2++; }
}
$mustsend = false;
$mailsubject = '';
$mailbody = '';
$mailerrormsg = '';
if(isset($_POST['exporttomail']) AND is_numeric($_POST['exporttomail'])){
  $exporttomail = $admin->get_post('exporttomail');
  $_SESSION['export']['exporttomail'] = $exporttomail;
  $exportmailadr = $admin->get_post('exportmailadr');
}
else{
  $exporttomail = 0;
  $exportmailadr='';
}
$autosend = $admin->get_post('autosend');
$outtype = $admin->get_post('outtype');
$print_opt = $admin->get_post('print_opt');
$print_pdf = ($print_opt=='pdf'?true:false);
$_SESSION['export']['print_opt'] = $print_opt;
$print_sum = $admin->get_post('print_sum');
$_SESSION['export']['print_sum'] = $print_sum;
$print_statistic = $admin->get_post('print_statistic');
$_SESSION['export']['print_statistic'] = $print_statistic;
$_SESSION['export']['outtype'] = $outtype;
$sort = $admin->get_post('sorted_by');
$_SESSION['export']['sorted_by'] = $sort;
$db_fields = ""; // this fields are needed every time
$db_fields2 = ""; // this fields are needed every time
$saveastempl = $admin->get_post('saveastempl');
if($saveastempl == 1){
  // Check the field print statistic before save
  $new_fields = false;
  $get_fields = $datapdo->query("SHOW FIELDS FROM `".TABLE_PREFIX."res_exportset`");
  while($row = $datapdo->fetchRow($get_fields)){
    if($row[0]=='print_statistic'){ $new_fields = true; }
  }
  if($new_fields == false){
    $datapdo->query("ALTER TABLE `".TABLE_PREFIX."res_exportset` ADD `print_statistic` TINYINT(1) NOT NULL AFTER `print_sum`");
  }

  if($is_object == true){
    if($datapdo->numRows($datapdo->query("SELECT `exportset_id` FROM `".TABLE_PREFIX."res_exportset` WHERE `object_id`='$object_id' LIMIT 0,1"))>0){
      $datapdo->query("UPDATE `".TABLE_PREFIX."res_exportset` SET"
			     ." `outtype`='$outtype',"
			     ." `fields`='$fldforsave',"
			     ." `print_opt`='$print_opt',"
			     ." `print_sum`='$print_sum',"
			     ." `print_statistic`='$print_statistic',"
			     ." `exporttomail`='$exporttomail',"
			     ." `exportmailadr`='$exportmailadr',"
			     ." `sorted_by`='$sort'"
			     ." WHERE `object_id`='$object_id' LIMIT 1");
    }
    else{
      $datapdo->query("INSERT INTO `".TABLE_PREFIX."res_exportset`"
			     ." (`object_id`,`outtype`,`fields`,`print_opt`,`print_sum`,`print_statistic`,`exporttomail`,`exportmailadr`,`sorted_by`) VALUES"
			     ." ('$object_id','$outtype','$fldforsave','$print_opt','$print_sum','$print_statistic','$exporttomail','$exportmailadr','$sort')");
    }
  }
}
$icsvar = array();
$icsval = array();
if($outtype == 'ics'){
  $outicshead = 'BEGIN:VCALENDAR'.chr(13).chr(10).'PRODID:-//BROM-BelCal '.BC_VERSION.chr(13).chr(10).'VERSION:2.0'.chr(13).chr(10).'CALSCALE:GREGORIAN'.chr(13).chr(10)
	      .'METHOD:PUBLISH'.chr(13).chr(10).'X-WR-CALNAME:[OBJECTNAME]'.chr(13).chr(10).'X-WR-TIMEZONE:Europe/Berlin'.chr(13).chr(10).'BEGIN:VTIMEZONE'.chr(13).chr(10)
	      .'TZID:Europe/Berlin'.chr(13).chr(10).'X-LIC-LOCATION:Europe/Berlin'.chr(13).chr(10).'BEGIN:DAYLIGHT'.chr(13).chr(10).'TZOFFSETFROM:+0100'.chr(13).chr(10)
	      .'TZOFFSETTO:+0200'.chr(13).chr(10).'TZNAME:CEST'.chr(13).chr(10).'DTSTART:19700329T020000'.chr(13).chr(10).'RRULE:FREQ=YEARLY;BYMONTH=3;BYDAY=-1SU'.chr(13).chr(10)
	      .'END:DAYLIGHT'.chr(13).chr(10).'BEGIN:STANDARD'.chr(13).chr(10).'TZOFFSETFROM:+0200'.chr(13).chr(10).'TZOFFSETTO:+0100'.chr(13).chr(10).'TZNAME:CET'.chr(13).chr(10)
	      .'DTSTART:19701025T030000'.chr(13).chr(10).'RRULE:FREQ=YEARLY;BYMONTH=10;BYDAY=-1SU'.chr(13).chr(10).'END:STANDARD'.chr(13).chr(10).'END:VTIMEZONE'.chr(13).chr(10);
  $outicsloophead = 'BEGIN:VEVENT'.chr(13).chr(10);
  $outicsloop = 'DTSTART:[RESSTART]'.chr(13).chr(10).'DTEND:[RESEND]'.chr(13).chr(10).'UID:[VEVENTUID]'.chr(13).chr(10).'CREATED:[LOGWHEN]'.chr(13).chr(10).'SEQUENCE:[ISMODIFY]'.chr(13).chr(10)
               .'DESCRIPTION:[DESCRIPTION]'.chr(13).chr(10).'LAST-MODIFIED:[LASTMODIFY]'.chr(13).chr(10).'STATUS:[STATUS]'.chr(13).chr(10).'SUMMARY:[SUMMARY]'.chr(13).chr(10).'TRANSP:OPAQUE'.chr(13).chr(10);
  $outicsloopfoot = 'END:VEVENT'.chr(13).chr(10);
  $outicsfoot = 'END:VCALENDAR';
  $db_fields = "r.`res_id`,r.`res_start`,r.`res_end`,r.`log_when`,r.`modified_when`,r.`status`,r.`covid`,r.`persons`,r.`children`,r.`name`,r.`more`,r.`mailtext`,a.`street`,a.`zipcode`,a.`city`,a.`phone`,a.`notice`,r.`object_id`";
  $fldn_array = array(0=>'res_id',1=>'res_start',2=>'res_end',3=>'log_when',4=>'modified_when',5=>'status',6=>'persons',7=>'children',8=>'name',9=>'more',10=>'mailtext',11=>'street',12=>'zipcode',13=>'city',14=>'phone',15=>'notice',16=>'covid');
  $is_addess = true;
  $is_calc = false;
}
else{
  foreach($field_array AS $id => $field){
    if($field != 'resfiles'){
      if(preg_match('/^c\./',$field)){ $db_fields2 .= (!empty($db_fields2)?',':'').$field; }
      else{ $db_fields .= (!empty($db_fields)?',':'').$field; }
    }
  }
}
if(empty($db_fields)){
  // Set all required fileds
  $db_fields .= "r.*,o.`object_title`";
  $db_fields .= ($is_address == true?",a.*":"");
}
else{
  $db_fields .= ",r.`res_id`,r.`object_id`"; // this fields are needed every time
}
if(empty($db_fields2)){
  $db_fields2 = (($is_calc == true AND empty($db_fields2))?"c.*":"");
}
// Get order settings
if($sort=='name' OR $sort=='prename' OR $sort=='city'){
  if($is_address == true){
    $order_sql = "a.`".$sort."`";
  }
  else{
    $order_sql = "r.`res_id`";
  }
}
else{
  $order_sql = "r.`".$sort."`";
}
if($outtype == 'ics'){ $order_sql = "r.`res_id`"; }
//$filter_sql3 = ($is_calc == true?" AND c.`res_id`='$res_id'":"");
$filter_sql2 .= ($is_address == true?" AND a.`client_id`=r.`client_id`":"");

$table_r = "`".TABLE_PREFIX."reservations` AS r";
$table_c = ($is_calc == true?"`".TABLE_PREFIX."res_price_calc`AS c":"");
$table_a = ($is_address == true?", `".TABLE_PREFIX."address` AS a":"");
$table_o = ", `".TABLE_PREFIX."obj_texts` AS o";
$output = '';
$sumT = 0;
$sumP = 0;
if($outtype == 'ics'){
  $st_string = array('CANCELLED','TENTATIVE','CONFIRMED','CONFIRMED','');
}
else{
  $st_string = array($CALTEXT['STORNO'],$CALTEXT['RES2'],$CALTEXT['RES3'],$CALTEXT['RES3s'],$CALTEXT['RES4']);
}
$covid_string = array($CALTEXT['COVID0'],$CALTEXT['COVID1'],$CALTEXT['COVID2'],$CALTEXT['COVID2a'],$CALTEXT['COVID2b'],$CALTEXT['COVID2c'],$CALTEXT['COVID3']);
$st_replac = array('0','2','3','4','5');
$covid_replac = array('0','1','2','3','4','5','6');
// get reservations form db like fields this object
$query = "SELECT $db_fields FROM ".$table_r.$table_a.$table_o." WHERE ".$filter_sql2.$filter_sql.$filter_objsql." AND o.`language`='".LANGUAGE."' ORDER BY $order_sql ASC";
$get_res = $datapdo->query($query);
if($datapdo->is_error()){
  $admin->print_error($datapdo->get_error(),str_replace(ARGSOJS,ARGSO,$all_back));
}
// Built the output like table
if($datapdo->numRows($get_res) > 0){
  $print_object = '';
  if(isset($object_id) AND $object_id!=0){ $o_temp = $admin->get_object_details($object_id); $print_object = ' - '.$o_temp['object_title']; }
  if($outtype == 'ics'){
    $output_title = $o_temp['obj_name'];
    $outicshead = str_replace('[OBJECTNAME]',$output_title,$outicshead);
  }
  else{
    $output_title = '<h2>'.$MENU['RESERVATIONS'].$print_object.'</h2>';
    $output_headline = '<table cellspacing="0" cellpadding="3" width="100%"><tr>'."\n";
    foreach($names_array AS $id => $thn){
      $output_headline .= '<th style="text-align:left;vertical-align:top;'.($print_pdf==true?'font-size:8pt;':'').'">'.$thn.'</th>'."\n";
    }
    $output_headline .= '</tr>'."\n";
  }
  $old_res_ids = array();
  while($output_line = $datapdo->fetchRow($get_res)){

    $statistics = ($statistics == ''?date(DATE_FORMAT,$output_line['res_start']):$statistics);
    $statistice = date(DATE_FORMAT,$output_line['res_end']);
    // Get the statistic data
    if(!isset($output_line['res_days'])){
      $plus = $datapdo->get_one("SELECT `countalldays` FROM `".TABLE_PREFIX."calendar` WHERE `object_id`='".$output_line['object_id']."' LIMIT 1");
      $output_line['res_days'] = ceil(($output_line['res_end']-$output_line['res_start'])/86400)+$plus;
    }
    if(isset($output_line['status']) AND isset($output_line['persons'])){
      switch ($output_line['status']){
        case 0:
          $rstatus_0++;
          $rstatus_0d += $output_line['res_days'];
          $fullp = $output_line['persons'];
          if(isset($output_line['children'])){ $fullp += $output_line['children']; }
          $rstatus_0p += $fullp;
          $rstatus_0s += ($fullp*$output_line['res_days']);
          break;
        case 2:
          $rstatus_2++;
          $rstatus_2d += $output_line['res_days'];
          $fullp = $output_line['persons'];
          if(isset($output_line['children'])){ $fullp += $output_line['children']; }
          $rstatus_2p += $fullp;
          $rstatus_2s += ($fullp*$output_line['res_days']);
          break;
        case 3:
          $rstatus_3++;
          $rstatus_3d += $output_line['res_days'];
          $fullp = $output_line['persons'];
          if(isset($output_line['children'])){ $fullp += $output_line['children']; }
          $rstatus_3p += $fullp;
          $rstatus_3s += ($fullp*$output_line['res_days']);
          break;
        case 4:
          $rstatus_4++;
          $rstatus_4d += $output_line['res_days'];
          $fullp = $output_line['persons'];
          if(isset($output_line['children'])){ $fullp += $output_line['children']; }
          $rstatus_4p += $fullp;
          $rstatus_4s += ($fullp*$output_line['res_days']);
          break;
        case 5:
          $rstatus_5++;
          $rstatus_5d += $output_line['res_days'];
          $fullp = $output_line['persons'];
          if(isset($output_line['children'])){ $fullp += $output_line['children']; }
          $rstatus_5p += $fullp;
          $rstatus_5s += ($fullp*$output_line['res_days']);
          break;
      }
    }
    else{ $print_statistic = 0; }
    $res_id = $output_line['res_id'];
    if(is_numeric(array_search($res_id,$old_res_ids)) OR ($outtype=='ics' AND $output_line['status']==5)){ continue; }
    array_push($old_res_ids,$res_id);
    if($is_calc == true){
      $get_prices = $datapdo->query("SELECT * FROM $table_c WHERE c.`res_id`='$res_id' LIMIT 0,1");
      if($datapdo->numRows($get_prices)>0){
        $prices = $datapdo->fetchRow($get_prices);
        $output_line['total_price'] = ($output_line['status']==0?$prices['storno_price']:($prices['fixed_price']>0?$prices['fixed_price']:$prices['total_price']));
//        $output_line['fixed_price'] = $prices['fixed_price'];
        $output_line['paid_price'] = $prices['paid_price'];
        $output_line['res_days'] = $prices['res_days'];
      }
      else{
        $output_line['total_price'] = '';
        $output_line['fixed_price'] = '';
        $output_line['paid_price'] = '';
        $plus = $datapdo->get_one("SELECT `countalldays` FROM `".TABLE_PREFIX."calendar` WHERE `object_id`='".$output_line['object_id']."' LIMIT 1");
        $output_line['res_days'] = ceil(($output_line['res_end']-$output_line['res_start'])/86400)+$plus;
      }
    }
    $output .= ($outtype=='ics'?$outicsloophead:'<tr>'."\n");
    $ics_summary = '';
    $ics_description = '';
    $ics_resstart = '';
    $ics_resend = '';
    $ics_lastmod = '';
    $ics_logwhen = '';
    $ics_status = '';
    foreach($fldn_array AS $id => $key){
      $t_align = 'left';
      switch ($key){
        case 'res_id':
        case 'object_id':
          $out = $admin->zero_to_number($output_line[$key]);
          if($outtype=='ics' AND $key=='res_id'){ $ics_summary .= $out; $veventuid = md5($out).$admin->get_email(); }
          break;
        case 'res_start':
        case 'res_end':
          if($outtype=='ics'){ $ics_resend = gmdate('Ymd',$output_line[$key]).'T'.date('His',($output_line[$key]-TIMEZONE)).'Z'; }
        case 'modified_when':
          if($outtype=='ics'){ $ics_lastmod = date('Ymd',$output_line[$key]).'T'.date('His',($output_line[$key]-TIMEZONE)).'Z'; }
        case 'log_when':
          $out = ($output_line[$key]==0?'':date('d.m.Y',$output_line[$key]));
          if($outtype=='ics'){
            $ics_date = date('Ymd',$output_line[$key]).'T'.date('His',($output_line[$key]-TIMEZONE)).'Z';
            if($key == 'res_start'){ $ics_resstart = $ics_date; }
            elseif($key == 'res_end'){ $ics_resend = $ics_date; }
            elseif($key == 'modified_when'){ $ics_lastmod = $ics_date; }
            elseif($key == 'log_when'){ $ics_logwhen = $ics_date; }
          }
          break;
        case 'total_price':
        case 'fixed_price':
        case 'paid_price':
          $t_align = 'right';
          if(!empty($output_line[$key])){
            $out = number_format($output_line[$key],2,$dec_point,$thousends);
            if($key=='fixed_price' AND $output_line[$key]>0){ $sumT += $output_line[$key]; }
            elseif($key=='total_price'){ $sumT += $output_line[$key]; }
            else{ $sumP += $output_line[$key]; }
          }
          else{ $out = ''; }
          break;
        case 'status':
          $t_align = 'center';
          $out = str_replace($st_replac,$st_string,$output_line[$key]);
          if($outtype=='ics'){ $ics_status = $out; }
          break;
        case 'covid':
          $t_align = 'center';
          $out = str_replace($covid_replac,$covid_string,$output_line[$key]);
          if($outtype=='ics'){ $ics_covid = $out; }
          break;
        case 'res_days':
        case 'persons':
        case 'children':
          if($outtype=='ics'){
            if($key != 'res_days'){ $ics_description .= ($key=='persons'?$CALTEXT['PERSONS']:$CALTEXT['CHILDREN']).': '.$output_line[$key]."\n"; }
          }
        case 'contingent':
          $t_align = 'center';
          $out = $output_line[$key];
          break;
        case 'more':
          // Get the current form this object
          $getfrmobj = $datapdo->get_one("SELECT `form_object` FROM `".TABLE_PREFIX."calendar` WHERE `object_id`='".$output_line['object_id']."' LIMIT 1");
	 $frmobj = ($getfrmobj = 0?$output_line['object_id']:$getfrmobj);
          $invalue = '';
          $mores_array = array();
          if($output_line[$key] != ''){
            $mores_array = unserialize($output_line[$key]);
          }
          if(count($mores_array) > 0){
            foreach($mores_array AS $mfID => $mtID){
              $getall_mores = $datapdo->query("SELECT lab.`field_extra` FROM `".TABLE_PREFIX."form_labels` AS lab LEFT JOIN `".TABLE_PREFIX."forms` AS frm ON lab.`field_id`=frm.`field_id` WHERE frm.`object_id`='$frmobj' AND frm.`field_id`='$mfID' AND (frm.`field_name`='MORE' OR frm.`forprices`='1') AND frm.`active`='1' AND lab.`language`='".LANGUAGE."' LIMIT 0,1");
              if($datapdo->numRows($getall_mores) > 0){
                $all_mores = $datapdo->fetchRow($getall_mores);
                $all_mores_array = explode('|',$all_mores['field_extra']);
                $inmores = explode('|',$mtID);
                foreach($inmores AS $mk => $mv){
                  $invalue .= ($invalue != ''? ' | ':'').'ID='.$mv.' - '.(substr($all_mores_array[$mv],0,1)=='+'?substr($all_mores_array[$mv],1,strlen($all_mores_array[$mv])):$all_mores_array[$mv]);
	       }
              }
            }
          }
          $out = $invalue;
          if($outtype=='ics'){ $ics_description .= $out."\n"; }
          break;
        case 'mailtext':
        case 'covid':
        case 'notice':
          if($outtype=='ics'){ $ics_description .= $output_line[$key]."\n"; }
          $out = nl2br($output_line[$key]);
          break;
        case 'resfiles':
          // Get all sended files this res id
          $outfiles = '';
          $get_filenames = $datapdo->query("SELECT `bil_number`,`title`,`savedate` FROM `".TABLE_PREFIX."res_files` WHERE `res_id`='$res_id' ORDER BY `savedate`ASC");
          if($datapdo->numRows($get_filenames)>0){
            while($filenames = $datapdo->fetchRow($get_filenames)){
              $filetitle = $filenames['title'];
              $filedate = date(DATE_FORMAT,$filenames['savedate']);
              $patt = "/".$filedate."/";
              if(preg_match($patt,$filetitle)){ $filedate = ''; }else{ $filedate = ' ('.$filedate.')'; }
              $outfiles .= ($outfiles!=''?chr(10):'').($filenames['bil_number']!=''?$filenames['bil_number'].' - ':'').$filenames['title'].$filedate;
            }
          }
          if($outtype=='ics'){ $ics_description .= $outfiles."\n"; }
          $out = nl2br($outfiles);
          break;
        default:
          $out = $output_line[$key];
          if($outtype=='ics'){
            if($key=='name'){ $ics_summary .= ' - '.$out; }else{ $ics_description .= $out."\n"; }
          }
      }
      if($outtype!='ics'){ $output .= '<td style="text-align:'.$t_align.';vertical-align:top;'.($print_pdf==true?'font-size:8pt;':'border-top:1px solid #555555;').'">'.$out.'</td>'; }
    }
    if($outtype=='ics'){
      $ics_ismod = ($ics_logwhen != $ics_lastmod ? '2' : '0');
      $icsvar = array('[VEVENTUID]','[RESSTART]','[RESEND]','[LOGWHEN]','[DESCRIPTION]','[LASTMODIFY]','[ISMODIFY]','[STATUS]','[SUMMARY]');
      $icsval = array($veventuid,$ics_resstart,$ics_resend,$ics_logwhen,preg_replace('/[\r\n]/','\\n',trim($ics_description.$ics_covid)),$ics_lastmod,$ics_ismod,$ics_status,$ics_summary);
      $output .= str_replace($icsvar,$icsval,$outicsloop);
    }
    $output .= ($outtype=='ics'?$outicsloopfoot:'</tr>'."\n");
  }
  if(!$is_export AND $print_sum == 1){
    $output .= '<tr>'."\n";
    $output .= '<td colspan="'.$sumspan1.'" style="font-weight:bold;text-align:right;vertical-align:top;'.($print_pdf==true?'font-size:8pt;':'border-top:1px solid #555555;').'">'.$CALTEXT['PRINTSUM'].' </td>'."\n";
    $output .= '<td style="font-weight:bold;text-align:right;vertical-align:top;'.($print_pdf==true?'font-size:8pt;':'border-top:1px solid #555555;border-bottom:3px double #555555;').'">'.number_format($sumT,2,$dec_point,$thousends).'</td>'."\n";
    $output .= '<td style="font-weight:bold;text-align:right;vertical-align:top;'.($print_pdf==true?'font-size:8pt;':'border-top:1px solid #555555;border-bottom:3px double #555555;').'">'.number_format($sumP,2,$dec_point,$thousends).'</td>'."\n";
    $output .= '<td colspan="'.$sumspan2.'" style="font-weight:bold;text-align:left;vertical-align:top;'.($print_pdf==true?'font-size:8pt;':'border-top:1px solid #555555;').'"> ('.$CALTEXT['OPENPRICE'].' '.number_format(($sumT-$sumP),2,$dec_point,$thousends).')</td>'."\n";
    $output .= '</tr>'."\n";
  }
  $output .= ($outtype=='ics'?'':'</table>');
  if(!$is_export AND $print_statistic == 1){
    $statistice = ((isset($_SESSION['filter']['end']) AND !empty($_SESSION['filter']['end']))?$_SESSION['filter']['end']:$statistice);
    $rstatus_g = $rstatus_0+$rstatus_2+$rstatus_3+$rstatus_4+$rstatus_5;
    $rstatus_d = $rstatus_0d+$rstatus_2d+$rstatus_3d+$rstatus_4d+$rstatus_5d;
    $rstatus_p = $rstatus_0p+$rstatus_2p+$rstatus_3p+$rstatus_4p+$rstatus_5p;
    $rstatistic_g = $rstatus_0s+$rstatus_2s+$rstatus_3s+$rstatus_4s+$rstatus_5s;
    $prtdays = '('.$TEXT['TERMIN_ANZ'].'/'.$TEXT['TERMIN_ANZN'].')';
    $prtstatdays = ' ('.$TEXT['TERMIN_ANZ'].'/'.$CALTEXT['ACCOUNT_NIGHTS'].')';
    $output .= '<h2 style="text-align:left;'.($print_pdf==true?'font-size:10pt;':'border-top:1px solid #555555;').'">'.$CALTEXT['STATISTIC'].' '.$statistics.' - '.$statistice.':</h2>'."\n";
    $output .= '<table cellspacing="0" cellpadding="3" width="100%">'."\n";
    $output .= '<tr>'."\n";
    $output .= '<td'.($rstatus_0==0?' style="color:lightgray;"':"").'>'.$CALTEXT['STORNO'].'='.$rstatus_0.'<br />'.$rstatus_0d.' '.$prtdays.'<br />('.$rstatus_0p.' '.$CALTEXT['PERSONS'].')</td>'."\n";
    $output .= '<td'.($rstatus_2==0?' style="color:lightgray;"':"").'>'.$CALTEXT['RES2'].'='.$rstatus_2.'<br />'.$rstatus_2d.' '.$prtdays.'<br />('.$rstatus_2p.' '.$CALTEXT['PERSONS'].')</td>'."\n";
    $output .= '<td'.($rstatus_3==0?' style="color:lightgray;"':"").'>'.$CALTEXT['RES3'].'='.$rstatus_3.'<br />'.$rstatus_3d.' '.$prtdays.'<br />('.$rstatus_3p.' '.$CALTEXT['PERSONS'].')</td>'."\n";
    $output .= '</tr>'."\n";
    $output .= '<tr style="font-weight:bold;">'."\n";
    $output .= '<td'.($rstatus_0==0?' style="color:lightgray;"':"").'>'.$rstatus_0s.$prtstatdays.'</td>'."\n";
    $output .= '<td'.($rstatus_2==0?' style="color:lightgray;"':"").'>'.$rstatus_2s.$prtstatdays.'</td>'."\n";
    $output .= '<td'.($rstatus_3==0?' style="color:lightgray;"':"").'>'.$rstatus_3s.$prtstatdays.'</td>'."\n";
    $output .= '</tr>'."\n";
    $output .= '<tr>'."\n";
    $output .= '<td'.($rstatus_4==0?' style="color:lightgray;"':"").'>'.$CALTEXT['RES3s'].'='.$rstatus_4.'<br />'.$rstatus_4d.' '.$prtdays.'<br />('.$rstatus_4p.' '.$CALTEXT['PERSONS'].')</td>'."\n";
    $output .= '<td'.($rstatus_5==0?' style="color:lightgray;"':"").'>'.$CALTEXT['RES4'].'='.$rstatus_5.'<br />'.$rstatus_5d.' '.$prtdays.'<br />('.$rstatus_5p.' '.$CALTEXT['PERSONS'].')</td>'."\n";
    $output .= '</tr>'."\n";
    $output .= '<tr style="font-weight:bold;">'."\n";
    $output .= '<td'.($rstatus_4==0?' style="color:lightgray;"':"").'>'.$rstatus_4s.$prtstatdays.'</td>'."\n";
    $output .= '<td'.($rstatus_5==0?' style="color:lightgray;"':"").'>'.$rstatus_5s.$prtstatdays.'</td>'."\n";
    $output .= '</tr>'."\n";
    $output .= '</table>'."\n";
  }
}
if(empty($output)){
  $admin->print_error($TEXT['NONE_FOUND'],str_replace(ARGSOJS,ARGSO,$all_back));
}
if(!$is_export){
  if($exporttomail>0 AND $exportmailadr!=''){
    $tomail = '';
    $tomailarray = explode(',',$exportmailadr);
    foreach($tomailarray AS $vmail){
      $vmail = trim($vmail);
      if($admin->validate_email($vmail)){
        $tomail .= (!empty($tomail)?',':'').$vmail;
      }
      $frommail = SERVER_EMAIL;
      $mailsubject = strip_tags($output_title);
      $mustsend = (!empty($tomail)?true:false);
    }
    if($saveastempl == 1 AND $is_object == true){ $datapdo->query("UPDATE `".TABLE_PREFIX."res_exportset` SET `exportmailadr`='$tomail' WHERE `object_id`='$object_id' LIMIT 1"); }
  }
  if($print_pdf==true){
    include_once(BC_PATH.'/lib/include/html2pdf/html2pdf_func.php');
    $temp = BC_PATH.'/temp/';
    $file = 'reslist.pdf';
    $pageorient = (count($fldn_array)>5?'L':'P');
    if(BC_VERSION >= 3.47){
      $outfile = built_pdf_file($output_title.$output_headline.$output,$temp,$file,'','','F',$pageorient);
    }
    else{
      $outfile = built_pdf_file($output_title.$output_headline.$output,$temp,$file,'','','F');
    }
    if(NULL === $outfile){
      $admin->print_error($TEXT['ERROR'],$js_back);
    }
    if($mustsend==true){
      $mailbody = '<html><body>'.$output_title.'<p>'.$MESSAGE['ATTACHMENT']['ADD_AS_PDF'].'<p>'.$MESSAGE['ATTACHMENT']['PDF_INFO'].'</p></body></html>';
      $mailattach = array(0=>array($temp.$file,$file));
    }
  }
  else{
    $outfile = BC_PATH.'/temp/reslist.html';
    $htmlhead = '<html><head><title>'.strip_tags($output_title).'</title>'."\n";
    $htmlhead .= '<meta http-equiv="Content-Type" content="text/html; charset='.(defined('DEFAULT_CHARSET')?DEFAULT_CHARSET:'utf-8').'" />'."\n";
    $htmlhead .= '<meta http-equiv="content-language" content="'.strtolower(LANGUAGE).'" />'."\n";
    if($mustsend==true){
      $mailbody = $htmlhead.'</head><body>'.$output_headline.$output.'</body></html>';
      $mailattach = array();
    }
    $output = $htmlhead.'</head><body onload="javascript:window.print()">'.$output_title.$output_headline.$output.'</body></html>';
//    $output = $htmlhead.'</head><body onload="javascript:window.print()"><p><a href="javascript:$(\"#printWin\").hide()">'.$TEXT['CLOSE'].'</a></p>'.$output_title.$output_headline.$output.'</body></html>';
//    $output = $htmlhead.'</head><body><p><a href="#" onclick="$(\"#printWin\").hide();">'.$TEXT['CLOSE'].'</a></p>'.$output_title.$output_headline.$output.'</body></html>';
    $fp = fopen($outfile,'w');
    if(FALSE === fwrite($fp,$output)){
      $admin->print_error($TEXT['ERROR'],$js_back);
    }
    fclose($fp);
  }
  if($mustsend==true){
    // Check the user has a mailbox
    $saveresult = true;
    $get_mbox = $datapdo->query("SELECT * FROM `".TABLE_PREFIX."mailboxes` WHERE `user_id`='".$admin->get_user_id()."' ORDER BY `mailbox_id` LIMIT 0,1");
    if($datapdo->numRows($get_mbox)>0){
      require_once(BC_PATH.'/lib/functions.php');
      $box = $datapdo->fetchRow($get_mbox);
      $mailbox = $box['position']-1;
      $pass = $admin->get_cryption($box['password'],$box['imapuser'],true);
      require_once(BC_PATH.'/lib/classes/class.imap.php');
      $imap = new imap($box['imapserver'],$box['imapport'],$box['imapuser'],$pass,$box['imaptype'],$box['sentfolder']);
      if(!$imap){ $saveresult = false; }
    }
    else{ $saveresult = false; }
    $sendresult = $admin->mail($frommail, $tomail, $mailsubject, $mailbody, '', 'html', $mailattach, $saveresult);
    if($sendresult == false){ $mailerrormsg = $TEXT['ERROR'].' '.$TEXT['SEND_TO_MAIL']; }
    else{
      if($saveresult == true){
        $insent = $imap->saveMailMsgInSent($sendresult);
        $imap = NULL;
      }
    }
  }
  $openfile = str_replace(BC_PATH,BC_URL,$outfile);
  if($mustsend==true AND $autosend==1){
    if($mailerrormsg==''){ $admin->print_success($TEXT['SUCCESS'],$all_back,1); }
    else{ $admin->print_error($mailerrormsg,$all_back); }
  }
  elseif(file_exists(BC_PATH.'/lib/winopen.inc.php')){ include(BC_PATH.'/lib/winopen.inc.php'); }
  else{
    echo '<script type="text/javascript">'."\n";
    echo '$(document).ready(function(){';
    echo '$("#printBox").show().focus();';
    echo '$("#printWin").attr("src","'.$openfile.'");';
//  if($print_pdf==false){ echo '$("#printWin").hide();'; }
//  else{ echo '$("#printWin").focusout(function(){ $("#printWin").hide(); });'; }
    echo '});'."\n";
    echo 'function closeBox(){ $("#printBox").hide(); }'."\n";
    echo '</script>'."\n";
    echo '<div id="printBox" style="display:none;position:absolute;z-index:99;top:10px;left:10px;width:750px;height:630px;background-color:#ffffff;border:5px groove lightgray;">'."\n";
    echo '<div style="width:99%;height:3%;border-bottom:1px solid gray;background-color:lightgray;cursor:pointer;;text-align:right;padding-right:1%;" onclick="closeBox();">'.$TEXT['CLOSE'].'</div>'."\n";
    echo '<iframe id="printWin" style="width:100%;height:97%;border:none;"></iframe>'."\n";
    echo '</div>'."\n";
  }

//  echo '<script type="text/javascript">window.open(\''.$openfile.'\',\'Listing\',\'menubar=yes,scrollbars=yes,status=no,toolbar=no,width=750,height=620,target=_blank\');</script>';
  flush();
  sleep(3);
//  $admin->print_success($mailerrormsg.$TEXT['SUCCESS'],$all_back,2);
//  $admin->print_error($mailerrormsg.$TEXT['SUCCESS'],$all_back);
}
else{
  if($outtype=='ics'){ $output = $outicshead.$output.$outicsfoot; }
  else{
    $is_header = (($admin->get_post('field_header') == 1)?true:false);
    $check_seperator1 = $admin->get_post('fseperator');
    if($admin->get_post('tseperator') == 2){ $check_seperator2 = '"'; }
    elseif($admin->get_post('tseperator') == 1){ $check_seperator2 = "'"; }
    else{ $check_seperator2 = ''; }

    switch ($check_seperator1){
      case 4:
        $seperator = '#';
        break;
      case 3:
        $seperator = '|';
        break;
      case 1:
        $seperator = ',';
        break;
      case 2:
      case 0:
      default:
        $seperator = ';';
    }
    $field_seperator = $check_seperator2.$seperator.$check_seperator2;
    // First remove the new lines
    $output = preg_replace('/[\r\n]/','',($is_header==true?$output_headline:'').$output);
    // The first replacements for csv
    $source = array('<tr>','</th>','</td>','<br />');
    $replac = array($check_seperator2,$field_seperator,$field_seperator,' - ');
    $output = str_replace($source,$replac,$output);
    // The second replacements
    $output = str_replace($field_seperator.'</tr>',$check_seperator2.chr(13).chr(10),$output);
    $output = strip_tags($output);
    $output = entities_to_umlauts($output,$local_charset);
  }
  $objname = strtolower(object_filename(strip_tags($output_title)));
  $filename = $objname.($outtype=='ics'?'.ics':'-'.gmdate('Y-m-d', time()+TIMEZONE).'.csv');
  // save the output file local
  header("Content-Type: text/plain");
  header("Content-Disposition: attachment; filename=".$filename);
  echo $output;
}
?>